import { useState, useCallback, useMemo, useEffect } from 'react';

function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
function _arrayWithHoles(r) {
  if (Array.isArray(r)) return r;
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e,
      n,
      i,
      u,
      a = [],
      f = true,
      o = false;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
    } catch (r) {
      o = true, n = r;
    } finally {
      try {
        if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(r, e) {
  return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest();
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}

var useAxiosLoader = function useAxiosLoader(axios) {
  var ignoredUrls = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    counter = _useState2[0],
    setCounter = _useState2[1];
  var inc = useCallback(function () {
    return setCounter(function (counter) {
      return counter + 1;
    });
  }, [setCounter]);
  var dec = useCallback(function () {
    return setCounter(function (counter) {
      return counter - 1;
    });
  }, [setCounter]);
  var urlIsIgnored = function urlIsIgnored(url) {
    return ignoredUrls.some(function (ignoredUrl) {
      return ignoredUrl.test(url);
    });
  };
  var interceptors = useMemo(function () {
    return {
      request: function request(config) {
        return !urlIsIgnored(config.url) && inc(), config;
      },
      response: function response(_response) {
        return counter >= 0 && dec(), _response;
      },
      // Decrement ONLY if counter has been incremented (avoid minus values)
      error: function error(_error) {
        return counter >= 0 && dec(), Promise.reject(_error);
      }
    };
  }, [inc, dec]); // create the interceptors

  useEffect(function () {
    // add request interceptors
    var reqInterceptor = axios.interceptors.request.use(interceptors.request, interceptors.error);
    // add response interceptors
    var resInterceptor = axios.interceptors.response.use(interceptors.response, interceptors.error);
    return function () {
      // remove all intercepts when done
      axios.interceptors.request.eject(reqInterceptor);
      axios.interceptors.response.eject(resInterceptor);
    };
  }, [interceptors]);
  counter < 0 && setCounter(0);
  return [counter > 0];
};

export { useAxiosLoader };
//# sourceMappingURL=index.es.js.map
